{$pbe ignore}
unit DefScript;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TPSForm = class(TForm)
    pScriptGUI: TPanel;
    FCmdLineParams: TEdit;
    FStartFolder: TEdit;
    FHideWindow: TCheckBox;
    FWaitFor: TCheckBox;
    FFileList: TMemo;
    FExcludeMasks: TMemo;
    FDontExpandMasks: TCheckBox;
    FOutputVar: TComboBox;    
    lbFCmdLineParams: TLabel;
    lbFStartFolder: TLabel;
    lbFFileList: TLabel;
    lbFExcludeMasks: TLabel;
    lbFOutputVar: TLabel;
    sbFStartFolder: TButton;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PSForm: TPSForm;

implementation

{$R *.dfm}

{$end pbe ignore}

procedure sbFStartFolderClick(Sender:TObject);
var
  s:string;  
  p:TPoint;
begin
  s:=FStartFolder.text;    
  p.x:=0; p.y:=sbFStartFolder.Height;
  p:=sbFStartFolder.ClientToScreen(p);
  if BrowseForFolder('Select a directory',s,s,p) then  
    FStartFolder.Text:=s;
end;


{---------- SaveSettings: Required method! -------------------------------------
  Here you can transform values from your GUI into the required fields
  of default Precision Builder Express command-line interface.   

  Fields description:  

  edParams.Text [required] 
    - command line parameters for the executed application (defined in action type "Advanced tab")

  mFileMask.Lines.Text [optional] 
    - the list of processed files (or any other parameters), that will be used 
      if edParams.Text contains the %FILE% macro
          
  mExcludeMask.Lines.Text [optional] 
    - the list of excluded masks, that is applied on files list (only if cbDontExpandMask.Checked is False),    
      or copied to the edParams.Text replacing the %EXCLUDE% macro
     
  edStartFolder.Text [optional] 
    - working folder for the executed application

  cbHideWindow.Checked [optional]
    - show or hide the application window 

  cbWaitFor.Checked [optional] 
    - wait for the application completion   

  cbDontExpandMask.Checked [optional] 
    - indicates that PBE should not expand the list of processed files before executing the action
      (let the executed application to handle the masks)

  cbVar.Text [optional]               
    - identifier of the project variable, where the output of application
      will be saved (only applicable when action type "Use output file" is checked)
-------------------------------------------------------------------------------}
procedure SaveSettings;
begin
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-1', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-2', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-3', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-4', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-5', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-6', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-7', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-8', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-9', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--best', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--brute', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--ultra-brute', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-t', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-d', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '-k', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--backup', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--compress-exports=0', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--compress-exports=1', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--compress-resources=0', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--compress-resources=1', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--compress-icons=0', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--compress-icons=1', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--compress-icons=2', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--compress-icons=3', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--strip-relocs=1', '', True, True);
  FCmdLineParams.Text := StrReplace(FCmdLineParams.Text, '--strip-relocs=0', '', True, True);

  case rgAction.ItemIndex of
    0: 
    begin
      case cbbCompression.ItemIndex of
        0:  FCmdLineParams.Text := FCmdLineParams.Text + ' -1';
        1:  FCmdLineParams.Text := FCmdLineParams.Text + ' -2';
        2:  FCmdLineParams.Text := FCmdLineParams.Text + ' -3';
        3:  FCmdLineParams.Text := FCmdLineParams.Text + ' -4';
        4:  FCmdLineParams.Text := FCmdLineParams.Text + ' -5';
        5:  FCmdLineParams.Text := FCmdLineParams.Text + ' -6';
        6:  FCmdLineParams.Text := FCmdLineParams.Text + ' -7';
        7:  FCmdLineParams.Text := FCmdLineParams.Text + ' -8';
        8:  FCmdLineParams.Text := FCmdLineParams.Text + ' -9';
        9:  FCmdLineParams.Text := FCmdLineParams.Text + ' --best';
        10: FCmdLineParams.Text := FCmdLineParams.Text + ' --brute';
        11: FCmdLineParams.Text := FCmdLineParams.Text + ' --ultra-brute';
      end;
    end;
    1:
    begin
      FCmdLineParams.Text := FCmdLineParams.Text + ' -d';
    end;
    2: 
    begin
      FCmdLineParams.Text := FCmdLineParams.Text + ' -t';
    end;
  end;

  if chkBackup.Checked then
  begin
    FCmdLineParams.Text := FCmdLineParams.Text + ' --backup';
  end;
  
  if chkCompressExports.Checked then
  begin
    FCmdLineParams.Text := FCmdLineParams.Text + ' --compress-exports=1';
  end else begin
    FCmdLineParams.Text := FCmdLineParams.Text + ' --compress-exports=0';
  end;

  if chkCompressResources.Checked then
  begin
    FCmdLineParams.Text := FCmdLineParams.Text + ' --compress-resources=1';
  end else begin
    FCmdLineParams.Text := FCmdLineParams.Text + ' --compress-resources=0';
  end;
  
  if chkStripRelocs.Checked then
  begin
    FCmdLineParams.Text := FCmdLineParams.Text + ' --strip-relocs=1';
  end else begin
    FCmdLineParams.Text := FCmdLineParams.Text + ' --strip-relocs=0';
  end;
  
  FCmdLineParams.Text := FCmdLineParams.Text + ' --compress-icons=' + IntToStr(cbbCompressIcons.ItemIndex);
  
  while Pos('  ', FCmdLineParams.Text) > 0 do
  begin
    FCmdLineParams.Text := Trim(StrReplace(FCmdLineParams.Text, '  ', ' ', True, True));
  end;

  mFileMask.Lines.Text     := FFileList.Lines.Text;
  mExcludeMask.Lines.Text  := FExcludeMasks.Lines.Text;
  edParams.Text            := FCmdLineParams.Text;
  edStartFolder.Text       := FStartFolder.Text;
  cbHideWindow.Checked     := FHideWindow.Checked;
  cbWaitFor.Checked        := FWaitFor.Checked;
  cbDontExpandMask.Checked := FDontExpandMasks.Checked;
  cbVar.Text               := FOutputVar.Text;
end;

{---------- LoadSettings: Required method! -------------------------------------
  Here you can transform the Precision Builder Express command-line interface
  fields into the values of your GUI. See the description of fields above.
-------------------------------------------------------------------------------}
procedure LoadSettings;
begin
  FCmdLineParams.Text      := edParams.Text;
  FStartFolder.Text        := edStartFolder.Text;
  FHideWindow.Checked      := cbHideWindow.Checked;
  FWaitFor.Checked         := cbWaitFor.Checked;
  FFileList.Lines.Text     := mFileMask.Lines.Text;
  FFileList.Hint           := FFileList.Hint + '|' + mFileMask.Hint;
  FExcludeMasks.Lines.Text := mExcludeMask.Lines.Text;
  FExcludeMasks.Hint       := FExcludeMasks.Hint + '|' + mExcludeMask.Hint;
  FDontExpandMasks.Checked := cbDontExpandMask.Checked;
  
  if cbVar.Parent = tsCommandLine then
  begin
    FOutputVar.Items.Text:=cbVar.Items.Text;
    FOutputVar.Text:=cbVar.Text;
  end
  else
  begin
    FOutputVar.Visible:=False;
    lbFOutputVar.Visible:=False;
  end;
  
  while Pos('  ', FCmdLineParams.Text) > 0 do
  begin
    FCmdLineParams.Text := Trim(StrReplace(FCmdLineParams.Text, '  ', ' ', True, True));
  end;

  if Pos('-1', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 0;
  end else if Pos('-2', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 1;
  end else if Pos('-3', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 2;
  end else if Pos('-4', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 3;
  end else if Pos('-5', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 4;
  end else if Pos('-6', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 5;
  end else if Pos('-7', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 6;
  end else if Pos('-8', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 7;
  end else if Pos('-9', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 8;
  end else if Pos('--best', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 9;
  end else if Pos('--brute', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 10;
  end else if Pos('--ultra-brute', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 0;
    cbbCompression.ItemIndex := 11;
  end else if Pos('-d', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 1;
  end else if Pos('-t', FCmdLineParams.Text) > 0 then
  begin
    rgAction.ItemIndex := 2;
  end;
  
  
  chkBackup.Checked := (Pos('-k', FCmdLineParams.Text) > 0) or (Pos('--backup', FCmdLineParams.Text) > 0);
  chkCompressExports.Checked := Pos('--compress-exports=1', FCmdLineParams.Text) > 0;
  chkCompressResources.Checked := Pos('--compress-resources=1', FCmdLineParams.Text) > 0;
  chkStripRelocs.Checked := Pos('--strip-relocs=1', FCmdLineParams.Text) > 0;

  if Pos('--compress-icons=0', FCmdLineParams.Text) > 0 then
  begin
    cbbCompressIcons.ItemIndex := 0;
  end; 
 
  if Pos('--compress-icons=1', FCmdLineParams.Text) > 0 then
  begin
    cbbCompressIcons.ItemIndex := 1;
  end; 
 
  if Pos('--compress-icons=2', FCmdLineParams.Text) > 0 then
  begin
    cbbCompressIcons.ItemIndex := 2;
  end; 
 
  if Pos('--compress-icons=3', FCmdLineParams.Text) > 0 then
  begin
    cbbCompressIcons.ItemIndex := 3;
  end; 
 

  sbFStartFolder.OnClick:=@sbFStartFolderClick;
end;

{---------- Main script body ---------------------------------------------------
  Calling the LoadSettings method is required!
-------------------------------------------------------------------------------}
begin
  LoadSettings;
end.